<template>
  <div class="p-2">
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="600px" :draggable="draggable">
      <el-form ref="formRef" v-loading="formLoading" :model="formData" :rules="formRules" label-width="80px">
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="formLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="dialog.visible = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="XfDiscounttermForm" lang="ts">
import * as XfDiscounttermApi from '@/api/consumption/xfDiscountterm';
import { XfDiscounttermForm } from '@/api/consumption/xfDiscountterm/types';
import { useI18n } from 'vue-i18n';

defineOptions({ name: 'XfDiscounttermForm' });

// 接收父组件传入属性
// const props = defineProps({})

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
// 国际化
const { t } = useI18n();

// 对话框
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
// 窗体是否可以拖动
const draggable = ref(true);
// 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formLoading = ref(false);
// 表单的类型：create - 新增；update - 修改
const formType = ref('');
// 表单引用
const formRef = ref<ElFormInstance>();
// 表单数据
const formData = ref<XfDiscounttermForm>({
  discountTermId: undefined,
  termId: undefined,
});
// 表单校验规则
const formRules = reactive({
  discountTermId: [{ required: true, message: '折扣Id,主键不能为空', trigger: 'blur' }],
  termId: [{ required: true, message: '设备Id不能为空', trigger: 'change' }],
});
/** 当前组件方法 */
/** 窗体打开事件 */
const open = async (type: string, id?: number) => {
  dialog.visible = true;
  dialog.title = t('action.' + type);
  formType.value = type;
  resetForm();
  // 修改时，设置数据
  if (id) {
    formLoading.value = true;
    try {
      const res = await XfDiscounttermApi.getXfDiscountterm(id);
      Object.assign(formData.value, res.data);
    } finally {
      formLoading.value = false;
    }
  }
};
/** 表单重置 */
const resetForm = () => {
  formData.value = {
    discountTermId: undefined,
    termId: undefined,
  };
  formRef.value?.resetFields();
};
// 传回给父组件的属性与方法
// 提供 open 方法，用于打开弹窗
defineExpose({ open });
/** 触发父组件的事件 */
/** 定义 success 事件，用于操作成功后的回调 */
const emit = defineEmits(['success']);
/** 提交按钮 */
const submitForm = async () => {
  // 校验表单
  if (!formRef) return;
  const valid = await formRef.value?.validate();
  if (!valid) return;
  // 提交请求
  formLoading.value = true;
  try {
    const data = formData.value as unknown as XfDiscounttermForm;
    if (formType.value === 'create') {
      await XfDiscounttermApi.addXfDiscountterm(data);
      proxy?.$modal.msgSuccess('新增成功');
    } else {
      await XfDiscounttermApi.updateXfDiscountterm(data);
      proxy?.$modal.msgSuccess('修改成功');
    }
    dialog.visible = false;
    // 发送操作成功的事件
    emit('success');
  } finally {
    formLoading.value = false;
  }
};

/** 初始化 */
onMounted(() => {});
</script>
